
/*
		bool IsEmpty();//ж϶ǷΪ
		bool IsFull();//ж϶Ƿ
		int GetLength();//г
		bool Push(ElementType element);//β(׷)Ԫ
		void PushCoverIfFull(ElementType element);// ʱи
		bool Pop(ElementType &item);//Ԫ
		void ClearQueue();//ն
		bool ReadFromPos(ElementType &item,int iPos);
*/
//***********WcqCycQueue.h***********

#ifndef _WCQCYCQUEUE
#define _WCQCYCQUEUE
#include<stdlib.h>

template<class ElementType>
class WcqCycQueue
{
	private:
		ElementType* m_pBase;//ŶԪصĻָ()
		int m_iTotalSize;	 //дС()
		
		int m_iHeadPos;		 //λ
		int m_iRearPos;		 //βλ(һԪصһλ)
		int m_iElementCount; //Ԫصĸ

		enum {DefQueueSize=1000,IncrementSize=100};//ȱʡС
	public:
		WcqCycQueue(int iQueueSize=DefQueueSize)
		{
			if(iQueueSize<1)iQueueSize=DefQueueSize;
			m_pBase=new ElementType[iQueueSize];
			if(m_pBase==NULL)
			{
				MessageBox(NULL,"洢ռʧ,Ӧóֹ!","ʾ",MB_OK);
				exit(1);
			}

			m_iHeadPos=m_iRearPos=0;
			m_iTotalSize=iQueueSize;
			m_iElementCount=0;
		}
	
		~WcqCycQueue()
		{
			if(m_pBase!=NULL)delete[]m_pBase;
			m_pBase=NULL;
			m_iHeadPos=m_iRearPos=0;
			m_iTotalSize=0;
			m_iElementCount=0;
		}
	
		bool IsEmpty()
		{//ж϶ǷΪ
			return m_iHeadPos==m_iRearPos;
		}

		bool IsFull()
		{ //ж϶Ƿ
			return (m_iRearPos+1)%m_iTotalSize == m_iHeadPos;
		}

		int GetLength()
		{//г
			return m_iElementCount;
			//return (rear - front + size) % size;
		}
		int GetFreeLength()
		{
			return m_iTotalSize-m_iElementCount;
		}

		bool Push(ElementType element)
		{//β(׷)Ԫ
			if(m_iElementCount == m_iTotalSize)
			{
				//AfxMessageBox("޷׷Ԫ!");
				return false;
			}
			m_iElementCount++;
			m_pBase[m_iRearPos]=element;
			m_iRearPos=(m_iRearPos+1)%m_iTotalSize;
			return true;
		}
		bool PushEx(ElementType element)
		{//β(׷)Ԫ,дС
			if(m_iElementCount == m_iTotalSize)
			{
				ElementType *pNewBase=new ElementType[m_iTotalSize+IncrementSize];
				if(pNewBase==NULL)return false;
				for(int i=0;i<m_iElementCount;i++)
				{
					*(pNewBase+i)=m_pBase[(m_iHeadPos+i)%m_iTotalSize];
				}
				*(pNewBase+i)=element;
				
				m_iElementCount++;
				m_iTotalSize+=IncrementSize;
				m_iHeadPos=0;
				m_iRearPos=i+1;

				delete[]m_pBase;
				m_pBase=pNewBase;
				return true;
			}
			
			m_iElementCount++;
			m_pBase[m_iRearPos]=element;
			m_iRearPos=(m_iRearPos+1)%m_iTotalSize;
			return true;
		}

		void PushCoverIfFull(ElementType element)
		{// ʱи
			if(m_iElementCount == m_iTotalSize)
			{
				m_pBase[m_iRearPos]=element;
				m_iHeadPos=m_iRearPos=(m_iRearPos+1)%m_iTotalSize;				
				return ;
			}
			m_iElementCount++;
			m_pBase[m_iRearPos]=element;
			m_iRearPos=(m_iRearPos+1)%m_iTotalSize;
		}

		bool Pop(ElementType &item)
		{//Ԫ
			if(m_iElementCount>0)
			{
				item = m_pBase[m_iHeadPos];
				m_iElementCount--;
				m_iHeadPos=(m_iHeadPos+1)%m_iTotalSize;
				return true;
			}
			return false;
		}

		void ClearQueue()
		{//ն
			m_iHeadPos=m_iRearPos=0;
			m_iElementCount=0;
		}

		ElementType ReadFromPos(int iPos)
		{
			ElementType item;
			memset(&item,0,sizeof(ElementType));
			if(m_iElementCount>iPos)
			{	
				item= m_pBase[(m_iHeadPos+iPos)%m_iTotalSize];
			}
			return item;
		}
};
#endif


